require "numru/vizshot"

module NumRu
  class VizShot
    @variables = nil

    alias :_plot :plot
    def plot(arg)
      _plot(arg)
      generate_variables
      variable_to_file_and_var
    end

    def get_variables
      @variables.flatten
    end

    def to_yaml_with_variables
      viz = self.semi_deep_clone
      viz.clear_file_and_var
      viz.to_yaml
    end

    def to_yaml_without_variables
      viz = self.semi_deep_clone
      viz.clear_variables
      viz.to_yaml
    end

    def variable_to_file_and_var
      @variables.length.times{|i|
        var = @variables[i]
        if var
          if var[0]
            var[0] = Variable.find(var[0]) unless Variable === var[0]
            names = var[0].file_and_variable_names
            @plots[i][:file] = names[0]
            @plots[i][:var] = names[1]
          end
          if var[1]
            var[1] = Variable.find(var[1]) unless Variable === var[1]
            names = var[1].file_and_variable_names
            @plots[i][:file2] = names[0]
            @plots[i][:var2] = names[1]
          end
        end
      }
    end

    def get_plots
      @plots.collect{|pl| pl.dup}
    end

    def get_size
      [ @set[:admin][:iwidth], @set[:admin][:iheight] ]
    end

    def get_itr
      @set[:fig]['itr']
    end

    protected
    def clear_variables
      @variables = nil
    end

    private
    def generate_variables
      @plots.length.times{|i|
        @variables ||= Array.new
        if (var = @plots[i].delete(:variable))
          @variables[i] =  [var.id || var]
        end
        if (var = @plots[i].delete(:variable2))
          @variables[i].push( var.id || var )
        end
      }
    end

    def clear_file_and_var
      @plots.each{|pl|
        pl.delete(:file)
        pl.delete(:var)
        pl.delete(:file2)
        pl.delete(:var2)
      }
    end

  end
end
