var x_axis = null;
var y_axis = null;
function selectXAxis() {
  select_x_axis = $('x_axis');
  select_y_axis = $('y_axis');
  if( select_x_axis ) {
    var old = x_axis;
    x_axis = select_x_axis.selectedIndex;
    var line_radio = $('analysis_draw_type_0');
    if ( line_radio && !(line_radio.checked) ) {
      if( x_axis == y_axis ) {
        if( select_y_axis ) {
          select_y_axis.selectedIndex = (x_axis==0 ? 1 : 0);
          selectYAxis();
        }
      }
    }
    changeDimensionStatus(old);
  }
}
function selectYAxis() {
  select_x_axis = $('x_axis');
  select_y_axis = $('y_axis');
  if( select_y_axis ) {
    var old = y_axis;
    y_axis = select_y_axis.selectedIndex;
    if( y_axis == x_axis ) {
      if( select_x_axis ) {
        select_x_axis.selectedIndex = (y_axis==0 ? 1 : 0);
        selectXAxis();
      }
    }
    changeDimensionStatus(old);
  }
}

var dimensions = new Array();
function changeDimensionStatus(old) {
  var id;
  if( !(old==null) )
    if( (old!=x_axis) && (old!=y_axis) )
      dimensions[old].disableRight();
  if( !(x_axis==null) )
    dimensions[x_axis].enableRight();
  var line_radio = $('analysis_draw_type_0');
  if( line_radio && !(line_radio.checked) )
    if( !(y_axis==null) )
      dimensions[y_axis].enableRight();
}

function selectDrawType() {
  var line_settings = $('draw_line');
  var tone_settings = $('draw_tone');
  var vector_settings = $('draw_vector');

  if(line_settings) Element.hide(line_settings);
  if(tone_settings) Element.hide(tone_settings);
  if(vector_settings) Element.hide(vector_settings);

  var line_radio = $('analysis_draw_type_0');
  if ( line_radio && line_radio.checked ) {
    Element.show(line_settings);
    if( $('y_axis') ) {
      Element.hide('y_axis_row');
      Element.show('x_axis_'+y_axis);
      dimensions[y_axis].disableRight();
    }
  } else {
    if( $('y_axis') ) {
      if (x_axis == y_axis) {
        if (x_axis == 0) y_axis = 1;
        else y_axis = 0;
          $('y_axis').options[y_axis].selected = true;
      }
      selectXAxis();
      selectYAxis();
      Element.show('y_axis_row');
    }
    var tone_radio = $('analysis_draw_type_1');
    var vect_radio = $('analysis_draw_type_2');
    if( tone_radio && tone_radio.checked ) {
      Element.show(tone_settings);
    } else if( vect_radio && vect_radio.checked ) {
      Element.show(vector_settings);
    }
  }
}


var variablesOrder = new Array();
function selectVarOrder(select,type,i) {
  var new_num = select.selectedIndex;
  var old_num = variablesOrder[type][i];
  variablesOrder[type][i] = new_num;
  for(n=0;n<variablesOrder[type].length;n++){
    if(n==i) continue;
    sel = $(type+'_variables_order_'+n);
    if(sel.selectedIndex == new_num){
      sel.options[old_num].selected = true;
      variablesOrder[type][n] = old_num;
      break;
    }
  }
}


var executable;
function afterCallBack() {
  Element.hide("analysis_button");
  Element.hide("draw_button");
  if( action_type == 0 ) {
    dimensions.each( function(v,i){ v.disableRight(); } );
    selectXAxis();
    selectYAxis();
    selectDrawType();
    Element.show("popular_diagrams");
    if( executable )
      Element.show("draw_button");
  }
  if( action_type == 1 ) {
    Element.hide("popular_diagrams");
    if( executable )
      Element.show("analysis_button");
  }
}


function openOptionMenu() {
  Element.hide('open_menu_link');
  Element.show('option_menu');
}

function closeOptionMenu() {
  Element.hide('option_menu');
  Element.show('open_menu_link');
}

shrinkHalf = function(element) {
  element = $(element);
  var options = Object.extend({
    moveTransition: Effect.Transitions.sinoidal,
    scaleTransition: Effect.Transitions.sinoidal,
    opacityTransition: Effect.Transitions.none
  }, arguments[1] || {});
  var oldStyle = {
    top: element.style.top,
    left: element.style.left,
    height: element.style.height,
    width: element.style.width,
    opacity: element.getInlineOpacity() };

  var dims = element.getDimensions();
  var moveX = dims.width / 2;
  var moveY = dims.height / 2;
  return new Effect.Parallel(
    [ new Effect.Opacity(element, { sync: true, to: 0.0, from: 1.0, transition:
options.opacityTransition }),
      new Effect.Scale(element, 0.5, { sync: true, transition:
options.scaleTransition})
    ], Object.extend({
         beforeStartInternal: function(effect) {
           effect.effects[0].element.makePositioned();
           effect.effects[0].element.makeClipping(); },
         afterFinishInternal: function(effect) {
           effect.effects[0].element.undoClipping();
           effect.effects[0].element.undoPositioned();
}
       }, options)
  );
}



function showOption(category, name) {
  var first = arguments[2];
  full_name = category+"_"+name+"_option";
  var element = $(full_name);
  Element.show(element);
  Element.hide("add_"+full_name+"_link");
  Element.show("hide_"+full_name+"_link");
  if( !first )
    new Effect.Highlight(element, {
      duration: 3.0
    });
  setCookie("option_" + category + "_" + name, "true", null);
}

function hideOption(category, name) {
  full_name = category+"_"+name+"_option";
  Element.hide("hide_"+full_name+"_link");
  Element.show("add_"+full_name+"_link");
  Effect.Fade(full_name);
  setCookie("option_" + category + "_" + name, "false", null);
}

function showOptions(category) {
  Element.show(category+"_options");
  Element.show(category+"_options_menu");
}

function hideOptions(category) {
  Element.hide(category+"_options");
  Element.hide(category+"_options_menu");
}

var action_type;
function changeActionType(type) {
  action_type = type;
  new Ajax.Request(gfdnaviUrlRoot + "/analysis/action_type_selected",
                   {asynchronous: true,
                    evalScripts: true,
                    parameters: 'action_type=' + type,
                    method: 'post',
                    onLoading: function(){ progressText.start($('progress')); },
                    onComplete: function(res){ progressText.stop(); },
                    onFailure: function(res){
                        $('messages').update('error occured in server<br><div class="information"><p>'+res.responseText+"</p></div>");
                      }
                   });
  return false;
}

function changeVariable() {
  form = $('variables_body');
  new Ajax.Request(gfdnaviUrlRoot + "/analysis/variables_selected",
                   {asynchronous: true,
                    evalScripts: true,
                    parameters: Form.serialize(form),
                    method: 'post',
                    onLoading: function(){ progressText.start($('progress')); },
                    onComplete: function(res){ progressText.stop(); },
                    onFailure: function(res){
                        $('messages').update('error occured in server<br><div class="information"><p>'+res.responseText+"</p></div>");
                      }
                   });
  return false;
}

actionExecuteHook = {
                     onLoading: function(){
                         $("draw_button").disabled = true;
                         $("analysis_button").disabled = true;
                         progressText.start($('progress'));
                       },
                     onComplete: function(res){
                        progressText.stop();
                        $("draw_button").disabled = false;
                        $("analysis_button").disabled = false;
                       },
                     onFailure: function(res){
                        $('messages').update('error occured in server<br><div class="information"><p>'+res.responseText+"</p></div>");
                       }
}

function changeFunctionInputNum(select) {
  new Ajax.Request(gfdnaviUrlRoot + "/analysis/function_input_num_selected",
                   Object.extend({
                     asynchronous:true,
                     evalScripts:true,
                     parameters: 'function_input_num=' + select.value,
                     method: 'post'
                   }, actionExecuteHook)
                  );
  return false;
}

var functionArguments = null;
function selectFunction(select) {
  var index = select.selectedIndex;
  var ary = functionArguments[index];
  var html = "";
  if (ary.length > 0) {
    html += 'Arguments for the function';
    html += '<table>';
    for(i=0;i<ary.length;i++){
      html += '  <tr>';
      html += '    <td><input type="text" size="3" value="' + ary[i][1] + '" name="analysis[function_arguments][' + i + ']"/></td>';
      html += '    <td nowrap>' + ary[i][0] + '</td>';
      html += '  </tr>';
    }
    html += '</table>';
  }
  Element.update('function_arguments',html);
  return false;
}

function actionExecute(action) {
  var action_form = $('action_form');
  var variable_form = $('variables_body');
  new Ajax.Request(gfdnaviUrlRoot + "/analysis/execute",
                   Object.extend({
                     asynchronous:true,
                     evalScripts:true,
                     parameters: Form.serialize(variable_form)+'&'+Form.serialize(action_form)+'&action_type='+action,
                     method: 'post'
                   }, actionExecuteHook)
                  );
  return false;
}

function actionDropDiagram(upper, lower) {
  new Ajax.Request(gfdnaviUrlRoot + '/analysis/pile_up?upper=' + upper + '&lower=' + lower,
                   Object.extend({
                     asynchronous:true,
                     evalScripts:true
                   }, actionExecuteHook)
                  );
}


var num_keywords = 0;
function addRowKeyword() {
  var row;
  num_keywords = num_keywords + 1;
  row = "<tr>\n"
  row += "<td><input type='text' name='keywords[" + num_keywords + "][name]' id='save_keywords_" + num_keywords + "_name'/></td>\n"
  row += "<td><input type='text' name='keywords[" + num_keywords + "][value]' id='save_keywords_" + num_keywords + "_value'/></td>\n"
  row += "</tr>\n"
  new Insertion.Bottom($('save_keywords'),row);
}
