dial_image = gfdnaviUrlRoot + "/images/slider_f.gif";

var Dial = Class.create();
Object.extend(Dial.prototype, Draggable.prototype);
Object.extend(Dial.prototype, {
  updateDrag: function(event, pointer) {
    var offset = this.offset[0];
    offset += Position.cumulativeOffset(this.element)[0];
    offset -= this.currentDelta()[0];
    offset -= this.relative_offset;
    var pos = pointer[0] - offset;
    var index = this.slider.posToIndex(pos, this.min, this.max);
    var ary = this.slider.indexToValAndPos(index);
    this.text.value = ary[0];
    pos = ary[1];
    pointer[0] = pos + offset;
    if(this.set_bound)
      this.set_bound(index);
    if(this.come_up)
      this.come_up();
    Draggable.prototype.updateDrag.apply(this, arguments);
  }
});

var Slider = Class.create();
Slider.prototype = {
  initialize: function(name, width, text_size, ary, make_right, left_default, right_default) {

    element = $(name);

    left_obj = new Object();
    this.left_obj = left_obj;

    left_obj.text_id = name+"_left_text";
    left_obj.dial_id = name+"_left_dial";
    if(make_right) {
      right_obj = new Object();
      this.right_obj = right_obj;
      right_obj.text_id = name+"_right_text";
      right_obj.dial_id = name+"_right_dial";
    }
    back_id = name+"_back";
    td_id = name+"_td";
    this.back_id = back_id;

    var text_var;

    var html = '<table><tr>';
    if(left_default != null)
      text_var = left_default;
    else
      text_var = ary.first();
    html += '<td><input type="text" name="' + name + '[min]" id="' + left_obj.text_id + '" size="' + text_size + '" value="' + text_var +'"/></td>';
    html += '<td id="' + td_id + '">';
    html += '<div id="' + back_id + '" style="width:' + width +';height:' + 0 + ';"><hr style="position:relative;top:1ex"/></div>';
    html += '<span id="' + left_obj.dial_id + '" style="position:relative;"></span>';
    if(make_right)
      html += '<span id="' + right_obj.dial_id + '" style="position:relative;"></span>';
    html += '</td>'
    if(make_right) {
      if(right_default != null)
        text_var = right_default;
      else
        text_var = ary.last();
      html += '<td><input type="text" name="' + name + '[max]" id="' + right_obj.text_id + '" size="' + text_size + '" value="' + text_var + '" /><td>'
    }
    html += '</tr></table>';
    element.update(html);

    var imgl = new Image();
    imgl.src = dial_image;
    imgl.alt = name+"_min";
    left_obj.dial_dom = $(left_obj.dial_id);
    left_obj.dial_dom.appendChild(imgl);
    left_obj.dial_img = imgl;
    if(make_right) {
      var imgr = new Image();
      imgr.src = dial_image;
      imgr.alt = name+"_max";
      right_obj.dial_dom = $(right_obj.dial_id);
      right_obj.dial_dom.appendChild(imgr);
      right_obj.dial_img = imgr;
    }

    left_obj.text_dom = $(left_obj.text_id);
    Event.observe(left_obj.text_dom, 'change', this.moveLeftDial.bind(this));
    if(make_right) {
      right_obj.text_dom = $(right_obj.text_id);
      Event.observe(right_obj.text_dom, 'change', this.moveRightDial.bind(this));
    }

    var left_bound =  0;
    this.left_bound = left_bound;
    //var img_width =  imgl.width;
    var img_width =  11;
    this.right_bound = left_bound + width - img_width;

    this.ary = ary;

    var options = {
      constraint: 'horizontal',
      starteffect: null,
      endeffect: null
    };
    left_obj.dial = new Dial(left_obj.dial_dom, options);
    left_obj.dial.min = 0;
    left_obj.dial.max = ary.length-1;
    left_obj.dial.text = left_obj.text_dom;
    left_obj.dial.slider = this;
    left_obj.dial.relative_offset = 0;

    if(make_right) {
      right_obj.dial = new Dial(right_obj.dial_dom, options);
      right_obj.dial.min = 0;
      right_obj.dial.max = ary.length-1;
      right_obj.dial.text = right_obj.text_dom;
      right_obj.dial.slider = this;
      right_obj.dial.relative_offset = img_width;

      left_obj.dial.set_bound = function(index) {
        this.slider.right_obj.dial.min = index;
      };
      left_obj.dial.come_up = function() {
        this.slider.left_obj.dial_dom.style.zIndex = 2;
        this.slider.right_obj.dial_dom.style.zIndex = 1;
      }

      right_obj.dial.set_bound = function(index) {
        this.slider.left_obj.dial.max = index;
      }
      right_obj.dial.come_up = function() {
        this.slider.right_obj.dial_dom.style.zIndex = 2;
        this.slider.left_obj.dial_dom.style.zIndex = 1;
      }
    }

    this.moveLeftDial();
    if(this.right_obj)
      this.moveRightDial();
  },

  enableRight: function() {
    this.right_obj.text_dom.disabled = false;
    Element.setOpacity(this.right_obj.dial_img, 1.0);
  },

  disableRight: function() {
    this.right_obj.text_dom.disabled = true;
    Element.setOpacity(this.right_obj.dial_img, 0.3);
  },

  moveLeftDial: function() {
    this.moveDial(this.left_obj);
  },

  moveRightDial: function() {
    this.moveDial(this.right_obj);
  },

  moveDial: function(obj) {
    var value = obj.text_dom.value;
    var index = this.valToIndex(value);
    var ary = this.indexToValAndPos(index);
    if(obj.dial.set_bound)
      obj.dial.set_bound(index);
    if(obj.dial.come_up)
      obj.dial.come_up();
    obj.text_dom.value = ary[0];
    obj.dial_dom.style.left = (ary[1]-obj.dial.relative_offset)+'px';
  },

  posToIndex: function(pos, min, max) {
    var flac = (pos-this.left_bound)/(this.right_bound-this.left_bound);
    var index = Math.round(flac*(this.ary.length-1));
    if (index < min) index = min;
    if (index > max) index = max;
    return index
  },

  valToIndex: function(val) {
    var min;
    var index;
    var diff;
    this.ary.each(function(v,i) {
      diff = Math.abs( v - val );
      if( i==0 || diff < min ) {
        min = diff;
        index = i;
      }
    });
    return index;
  },

  indexToValAndPos: function(index) {
    var val = this.ary[index];
    var pos = this.left_bound+(this.right_bound-this.left_bound)*index/(this.ary.length-1);
    return [val, pos]
  }

}
